package com.company.untitled2.web.screens;

import com.haulmont.chile.core.datatypes.impl.EnumClass;
import com.haulmont.cuba.gui.components.RadioButtonGroup;
import com.haulmont.cuba.gui.screen.Screen;
import com.haulmont.cuba.gui.screen.Subscribe;
import com.haulmont.cuba.gui.screen.UiController;
import com.haulmont.cuba.gui.screen.UiDescriptor;
import com.haulmont.cuba.web.widgets.CubaRadioButtonGroup;

import javax.inject.Inject;
import java.util.LinkedHashMap;
import java.util.Map;

@UiController("untitled2_RbgScreen")
@UiDescriptor("rbg-screen.xml")
public class RbgScreen extends Screen {

    @Inject
    private RadioButtonGroup rbg;

    @Subscribe
    public void onInit(InitEvent event) {

        Map<String, Integer> map = new LinkedHashMap<>();


        for (RoleEnum roleEnum : RoleEnum.values()) {
            map.put(roleEnum.getName(), roleEnum.getId());
        }

        rbg.setOptionsMap(map);
        rbg.setValue(RoleEnum.DEV.getId());

        CubaRadioButtonGroup crbg = rbg.unwrap(CubaRadioButtonGroup.class);

        crbg.setItemEnabledProvider(i -> false);

    }

    private enum RoleEnum implements EnumClass<Integer> {

        DEV("Developer", 1),
        MGR("Manager", 2);

        private String name;
        private Integer value;

        RoleEnum(String name, Integer value) {
            this.name = name;
            this.value = value;
        }

        @Override
        public Integer getId() {
            return value;
        }

        public String getName() {
            return name;
        }
    }

}